'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Field = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _provider = require('../provider/provider');

var _provider2 = require('../provider/provider.actions');

var _provider3 = require('../provider/provider.utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Field = exports.Field = function (_React$Component) {
    _inherits(Field, _React$Component);

    function Field(props) {
        _classCallCheck(this, Field);

        var _this = _possibleConstructorReturn(this, (Field.__proto__ || Object.getPrototypeOf(Field)).call(this, props));

        _this.onChange = _this.onChange.bind(_this);
        _this.handleFieldChangeForward = _this.handleFieldChangeForward.bind(_this);
        _this.handleChange = _this.handleChange.bind(_this);
        _this.handleBlur = _this.handleBlur.bind(_this);
        _this.getChildProps = _this.getChildProps.bind(_this);
        _this.inject = _this.inject.bind(_this);
        _this.getFieldProps = _this.getFieldProps.bind(_this);

        _this.state = {
            valid: true,
            invalid: false,
            untouched: true,
            touched: false,
            pristine: true,
            dirty: false,
            unchanged: true,
            changed: false,
            errors: [],
            value: '',
            files: [],
            initialValue: props.initialValue || '',
            props: _this.getFieldProps(props)
        };

        return _this;
    }

    _createClass(Field, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            var _props = this.props,
                form = _props.form,
                name = _props.name,
                children = _props.children;

            if (Array.isArray(children) && children.length > 1) {
                throw 'The Field component for "' + form + '#' + name + '" should have only one child, but has ' + children.length + '.';
            }
            document.addEventListener(_provider2.REACT_FORMCTRL.EVENTS.FIELD_CHANGED + '#' + form + '#' + name, this.handleFieldChangeForward);

            _provider.FormEventDispatcher.dispatchRegisterField(form, name, this.state);
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            var nextFieldProps = this.getFieldProps(nextProps);
            if (!(0, _provider3.compareFieldProps)(this.state.props, nextFieldProps)) {
                _provider.FormEventDispatcher.dispatchFieldPropsChanged(this.props.form, this.props.name, nextFieldProps);
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var _props2 = this.props,
                form = _props2.form,
                name = _props2.name;

            document.removeEventListener(_provider2.REACT_FORMCTRL.EVENTS.FIELD_CHANGED + '#' + form + '#' + name, this.handleFieldChangeForward);
            _provider.FormEventDispatcher.dispatchUnregisterField(form, name);
        }
    }, {
        key: 'getFieldProps',
        value: function getFieldProps(props) {
            return {
                name: props.name,
                form: props.form,
                type: props.type,
                required: props.required,
                pattern: props.pattern,
                match: props.match,
                integer: props.integer,
                min: props.min,
                max: props.max,
                minLength: props.minLength,
                maxLength: props.maxLength,
                accept: props.accept,
                extensions: props.extensions || [],
                maxSize: props.maxSize,
                validate: props.validate
            };
        }
    }, {
        key: 'onChange',
        value: function onChange(fieldCtrl) {
            var onChange = this.props.onChange;

            if (typeof onChange === 'function') {
                onChange(fieldCtrl);
            }
        }
    }, {
        key: 'handleFieldChangeForward',
        value: function handleFieldChangeForward(event) {
            var payload = event.detail;
            var fieldCtrl = payload.fieldCtrl;
            this.setState(fieldCtrl);
            this.onChange(fieldCtrl);
        }
    }, {
        key: 'handleChange',
        value: function handleChange(event) {
            var sync = this.sync;
            var _props3 = this.props,
                form = _props3.form,
                name = _props3.name;

            var target = event.target;
            var value = target.value;
            var files = target.files;
            _provider.FormEventDispatcher.dispatchFieldChanged(form, name, value, files);
        }
    }, {
        key: 'handleBlur',
        value: function handleBlur(event) {
            if (this.state.untouched) {
                var _props4 = this.props,
                    form = _props4.form,
                    name = _props4.name;

                _provider.FormEventDispatcher.dispatchFieldBlur(form, name, _extends({}, this.state, { touched: true, untouched: false }));
            }
        }
    }, {
        key: 'getChildProps',
        value: function getChildProps() {
            var props = {};
            props.name = this.props.name;
            props.formName = this.props.form;
            props.ctrl = {
                valid: this.state.valid,
                invalid: this.state.invalid,
                untouched: this.state.untouched,
                touched: this.state.touched,
                pristine: this.state.pristine,
                dirty: this.state.dirty,
                unchanged: this.state.unchanged,
                changed: this.state.changed,
                errors: this.state.errors
            };
            props.accept = this.props.accept;
            props.extensions = this.props.extensions;
            props.maxSize = this.props.maxSize;
            props.className = this.props.className;
            props.value = this.state.value;
            props.required = this.props.required;
            props.pattern = this.props.pattern;
            props.type = this.props.type || 'text';
            props.onChange = this.handleChange;
            props.onBlur = this.handleBlur;
            return props;
        }
    }, {
        key: 'inject',
        value: function inject() {
            var inject = this.props.inject;

            var props = this.getChildProps();
            if (typeof inject === 'function') {
                return inject(props);
            }
            return props;
        }
    }, {
        key: 'render',
        value: function render() {
            var inject = this.inject;
            var children = this.props.children;

            return _react2.default.cloneElement(children, _extends({}, children.props, inject()));
        }
    }]);

    return Field;
}(_react2.default.Component);

Field.propTypes = {
    name: _propTypes2.default.string.isRequired,
    form: _propTypes2.default.string.isRequired,
    className: _propTypes2.default.string,
    required: _propTypes2.default.bool,
    pattern: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.instanceOf(RegExp)]),
    type: _propTypes2.default.string,
    integer: _propTypes2.default.bool,
    inject: _propTypes2.default.func,
    match: _propTypes2.default.string,
    min: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
    max: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
    minLength: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
    maxLength: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
    accept: _propTypes2.default.string,
    extensions: _propTypes2.default.arrayOf(_propTypes2.default.string),
    maxSize: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
    validate: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.arrayOf(_propTypes2.default.string)])
};